scoreboard players add @s startCountdown 1
scoreboard players set @s resetCooldown 50
scoreboard players set @s check 0
scoreboard players set @s checkDelay 10

#teleport to playerstart node and stay there until "GO!"
#also reset relevant scoreboard variables
execute if entity @s[scores={startCountdown=1}] run scoreboard players set @s lap 1
execute if entity @s[scores={startCountdown=1}] run effect clear @s
execute if entity @s[scores={startCountdown=1}] run function parkour_grand_prix:game_logic/1/self_scoreboard_setup
execute if entity @s[scores={startCountdown=1}] run tp @s @e[limit=1,sort=random,distance=..50,tag=node,tag=playerstart]
execute if entity @s[scores={startCountdown=2..49}] run tp @s @e[limit=1,sort=nearest,tag=node,tag=playerstart]
execute if entity @s[scores={startCountdown=50}] run effect clear @s

#summon armor stands to indicate state to other players
execute if entity @s[scores={startCountdown=10}] run summon armor_stand ~ ~2.2 ~ {CustomName:"{\"text\":\"Ready?\",\"color\":\"red\",\"bold\":\"true\"}",CustomNameVisible:true,NoGravity:1,Marker:1b,NoGravity:1,Invulnerable:1,Invisible:1,Tags:["setscore"]}
execute if entity @s[scores={startCountdown=10}] run scoreboard players set @e[tag=setscore,sort=nearest,type=armor_stand] lifespan 20
execute if entity @s[scores={startCountdown=10}] run tag @e[tag=setscore,sort=nearest,type=armor_stand] remove setscore
execute if entity @s[scores={startCountdown=30}] run summon armor_stand ~ ~2.2 ~ {CustomName:"{\"text\":\"Set!\",\"color\":\"yellow\",\"bold\":\"true\"}",CustomNameVisible:true,NoGravity:1,Marker:1b,NoGravity:1,Invulnerable:1,Invisible:1,Tags:["setscore"]}
execute if entity @s[scores={startCountdown=30}] run scoreboard players set @e[tag=setscore,sort=nearest,type=armor_stand] lifespan 20
execute if entity @s[scores={startCountdown=30}] run tag @e[tag=setscore,sort=nearest,type=armor_stand] remove setscore
execute if entity @s[scores={startCountdown=50}] run summon armor_stand ~ ~2.2 ~ {CustomName:"{\"text\":\"GO!\",\"color\":\"green\",\"bold\":\"true\"}",CustomNameVisible:true,NoGravity:1,Marker:1b,NoGravity:1,Invulnerable:1,Invisible:1,Tags:["setscore"]}
execute if entity @s[scores={startCountdown=50}] run scoreboard players set @e[tag=setscore,sort=nearest,type=armor_stand] lifespan 10
execute if entity @s[scores={startCountdown=50}] run tag @e[tag=setscore,sort=nearest,type=armor_stand] remove setscore

#subtitle animation
execute if entity @s[scores={startCountdown=..9}] run title @s subtitle [""]
execute if entity @s[scores={startCountdown=10}] run title @s subtitle ["",{"text":"-","color":"red"},{"text":"-------------------","color":"white"}]
execute if entity @s[scores={startCountdown=12}] run title @s subtitle ["",{"text":"--","color":"red"},{"text":"------------------","color":"white"}]
execute if entity @s[scores={startCountdown=14}] run title @s subtitle ["",{"text":"---","color":"red"},{"text":"-----------------","color":"white"}]
execute if entity @s[scores={startCountdown=16}] run title @s subtitle ["",{"text":"----","color":"red"},{"text":"----------------","color":"white"}]
execute if entity @s[scores={startCountdown=18}] run title @s subtitle ["",{"text":"-----","color":"red"},{"text":"---------------","color":"white"}]
execute if entity @s[scores={startCountdown=20}] run title @s subtitle ["",{"text":"-","color":"gold"},{"text":"-----","color":"red"},{"text":"--------------","color":"white"}]
execute if entity @s[scores={startCountdown=22}] run title @s subtitle ["",{"text":"--","color":"gold"},{"text":"-----","color":"red"},{"text":"-------------","color":"white"}]
execute if entity @s[scores={startCountdown=24}] run title @s subtitle ["",{"text":"---","color":"gold"},{"text":"-----","color":"red"},{"text":"------------","color":"white"}]
execute if entity @s[scores={startCountdown=26}] run title @s subtitle ["",{"text":"----","color":"gold"},{"text":"-----","color":"red"},{"text":"-----------","color":"white"}]
execute if entity @s[scores={startCountdown=28}] run title @s subtitle ["",{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"----------","color":"white"}]
execute if entity @s[scores={startCountdown=30}] run title @s subtitle ["",{"text":"-","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"---------","color":"white"}]
execute if entity @s[scores={startCountdown=32}] run title @s subtitle ["",{"text":"--","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"--------","color":"white"}]
execute if entity @s[scores={startCountdown=34}] run title @s subtitle ["",{"text":"---","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"-------","color":"white"}]
execute if entity @s[scores={startCountdown=36}] run title @s subtitle ["",{"text":"----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"------","color":"white"}]
execute if entity @s[scores={startCountdown=38}] run title @s subtitle ["",{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"-----","color":"white"}]
execute if entity @s[scores={startCountdown=40}] run title @s subtitle ["",{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"-----","color":"white"}]
execute if entity @s[scores={startCountdown=42}] run title @s subtitle ["",{"text":"-","color":"green"},{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"----","color":"white"}]
execute if entity @s[scores={startCountdown=44}] run title @s subtitle ["",{"text":"--","color":"green"},{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"---","color":"white"}]
execute if entity @s[scores={startCountdown=46}] run title @s subtitle ["",{"text":"---","color":"green"},{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"--","color":"white"}]
execute if entity @s[scores={startCountdown=48}] run title @s subtitle ["",{"text":"----","color":"green"},{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"},{"text":"-","color":"white"}]
execute if entity @s[scores={startCountdown=50}] run title @s subtitle ["",{"text":"-----","color":"green"},{"text":"-----","color":"yellow"},{"text":"-----","color":"gold"},{"text":"-----","color":"red"}]
execute if entity @s[scores={startCountdown=51}] run title @s subtitle ["",{"text":"--------------------","color":"green"}]
execute if entity @s[scores={startCountdown=52}] run title @s subtitle ["",{"text":"------------------","color":"green"}]
execute if entity @s[scores={startCountdown=53}] run title @s subtitle ["",{"text":"----------------","color":"green"}]
execute if entity @s[scores={startCountdown=54}] run title @s subtitle ["",{"text":"--------------","color":"green"}]
execute if entity @s[scores={startCountdown=55}] run title @s subtitle ["",{"text":"------------","color":"green"}]
execute if entity @s[scores={startCountdown=56}] run title @s subtitle ["",{"text":"----------","color":"green"}]
execute if entity @s[scores={startCountdown=57}] run title @s subtitle ["",{"text":"--------","color":"green"}]
execute if entity @s[scores={startCountdown=58}] run title @s subtitle ["",{"text":"------","color":"green"}]
execute if entity @s[scores={startCountdown=59}] run title @s subtitle ["",{"text":"----","color":"green"}]
execute if entity @s[scores={startCountdown=60}] run title @s subtitle ["",{"text":"--","color":"green"}]
execute if entity @s[scores={startCountdown=61}] run title @s subtitle [""]

#sound effects
execute if entity @s[scores={startCountdown=10}] run playsound minecraft:block.note_block.pling master @s ~ ~100000 ~ 100000 1
execute if entity @s[scores={startCountdown=30}] run playsound minecraft:block.note_block.pling master @s ~ ~100000 ~ 100000 1
execute if entity @s[scores={startCountdown=50}] run playsound minecraft:entity.firework_rocket.large_blast master @s ~ ~ ~ 100000 1

#title animation
execute if entity @s[scores={startCountdown=..9}] run title @s title [""]
execute if entity @s[scores={startCountdown=10..29}] run title @s title ["",{"text":"Ready?","bold":"true","color":"red"}]
execute if entity @s[scores={startCountdown=30..49}] run title @s title ["",{"text":"Set!","bold":"true","color":"yellow"}]
execute if entity @s[scores={startCountdown=50}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=52}] run title @s title ["",{"text":"GO!","bold":"true","color":"dark_green"}]
execute if entity @s[scores={startCountdown=54}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=56}] run title @s title ["",{"text":"GO!","bold":"true","color":"dark_green"}]
execute if entity @s[scores={startCountdown=58}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=60}] run title @s title ["",{"text":"GO!","bold":"true","color":"dark_green"}]
execute if entity @s[scores={startCountdown=62}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=64}] run title @s title ["",{"text":"GO!","bold":"true","color":"dark_green"}]
execute if entity @s[scores={startCountdown=66}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=68}] run title @s title ["",{"text":"GO!","bold":"true","color":"dark_green"}]
execute if entity @s[scores={startCountdown=70}] run title @s title ["",{"text":"GO!","bold":"true","color":"green"}]
execute if entity @s[scores={startCountdown=72..}] run title @s title [""]

#done with this function, get out
scoreboard players set @s[scores={startCountdown=72..}] startCountdown 100