#bring up extra hotbar options when things are selected
execute if entity @e[tag=selected] run tag @s add selecting

#drop egg, bring up config menus
execute if entity @s[scores={dropCowEgg=1..}] run function parkour_grand_prix:game_logic/2/config_finishline
execute if entity @s[scores={dropSheepEgg=1..}] run function parkour_grand_prix:game_logic/2/config_checkpoint

#throw snowball to select the nearest unselected node
execute if entity @s[scores={snowball=1..}] run tag @e[sort=nearest,limit=1,tag=!selected,tag=node] add selected
execute if entity @s[scores={snowball=1..}] run scoreboard players reset @s snowball
kill @e[type=snowball,distance=..2]

#drop barrier to deselect all selected nodes
execute if entity @s[scores={dropBarrier=1..}] run effect clear @e[tag=selected,tag=node]
execute if entity @s[scores={dropBarrier=1..}] run tag @e[tag=selected,tag=node] remove selected
execute if entity @s[scores={dropBarrier=1..}] run scoreboard players reset @s dropBarrier

#throw ender pearl to make all selected nodes face you
execute if entity @s[scores={enderPearl=1..}] as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ facing entity @a[sort=nearest,limit=1,scores={playerState=2,enderPearl=1..}] feet
execute if entity @s[scores={enderPearl=1..}] run tellraw @s ["",{"text":"All selected nodes are now facing you (throw again or reconnect to correct a render bug)","color":"aqua"}]
execute if entity @s[scores={enderPearl=1..}] run scoreboard players reset @s enderPearl
kill @e[type=ender_pearl,distance=..2]

#bring up node face direction menu
execute if entity @s[scores={dropDispenser=1..}] run tellraw @s ["",{"text":"Set face direction:","bold":true},{"text":" "},{"text":"[NORTH]","color":"yellow","clickEvent":{"action":"run_command","value":"/execute as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ 180 0"},"hoverEvent":{"action":"show_text","value":"North (negative Z)"}},{"text":" ","color":"yellow"},{"text":"[EAST]","color":"yellow","clickEvent":{"action":"run_command","value":"/execute as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ -90 0"},"hoverEvent":{"action":"show_text","value":"East (positive X)"}},{"text":" ","color":"yellow"},{"text":"[SOUTH]","color":"yellow","clickEvent":{"action":"run_command","value":"/execute as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ 0 0"},"hoverEvent":{"action":"show_text","value":"South (positive Z)"}},{"text":" ","color":"yellow"},{"text":"[WEST]","color":"yellow","clickEvent":{"action":"run_command","value":"/execute as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ 90 0"},"hoverEvent":{"action":"show_text","value":"West (negative X)"}},{"text":" "},{"text":"[CUSTOM]","color":"light_purple","clickEvent":{"action":"suggest_command","value":"/execute as @e[tag=node,tag=selected] at @s run tp @s ~ ~ ~ yaw pitch"},"hoverEvent":{"action":"show_text","value":"Custom (set yaw/pitch manually)"}},{"text":" ","color":"light_purple"},{"text":"[NUDGE]","color":"aqua","clickEvent":{"action":"run_command","value":"/function parkour_grand_prix:game_logic/2/rotate_menu"},"hoverEvent":{"action":"show_text","value":"Nudge (adjust relative rotation)"}}]
execute if entity @s[scores={dropDispenser=1..}] run scoreboard players reset @s dropDispenser

#selected nodes glow
effect give @e[tag=selected,tag=node] minecraft:glowing 2 0 true

#spawn egg was used, create a node or use the eraser
execute if entity @s[tag=executor] if entity @e[type=drowned,tag=killme,distance=..10] run function parkour_grand_prix:game_logic/2/spawn_playerstart
execute if entity @s[tag=executor] if entity @e[type=cow,tag=killme,distance=..10] run function parkour_grand_prix:game_logic/2/spawn_finishline
execute if entity @s[tag=executor] if entity @e[type=sheep,tag=killme,distance=..10] run function parkour_grand_prix:game_logic/2/spawn_checkpoint
execute if entity @s[tag=executor,tag=!selecting] if entity @e[type=creeper,tag=killme,distance=..10] run function parkour_grand_prix:game_logic/2/spawn_eraser
execute if entity @s[tag=executor,tag=selecting] if entity @e[type=creeper,tag=killme,distance=..10] run function parkour_grand_prix:game_logic/2/spawn_eraser_selecting

#if player is executor, cause nearby nodes to show visual boundaries
execute if entity @s[tag=executor] as @e[tag=node,tag=!playerstart,distance=..10,limit=1,sort=nearest] at @s run function parkour_grand_prix:game_logic/2/visualize_boundaries
execute if entity @s[tag=executor] as @e[tag=node,distance=..10,limit=20,sort=nearest] at @s run function parkour_grand_prix:game_logic/2/node_particle